-- plugin to provide info on Delvings and Malices
-- ToDo
-- move font select to menu

-- create options window and add to menu - options window should include stuff like window position (in case we lose track of it), colors, etc.

-- add an optional alert for Fervour days?

-- need descriptions for missions
-- need all DE/FR translations... 

importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."
pluginName=plugin:GetName()

import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()

MinWidth=740
MinHeight=215

if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end
-- This is the callback mechanism provided by Pengoros, slightly modified to guarantee uniqueness
function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
	else
		if (type(object[event]) == "table") then
			local exists=false;
			local k,v;
			for k,v in ipairs(object[event]) do
				if v==callback then
					exists=true;
					break;
				end
			end
			if not exists then
				table.insert(object[event], callback);
			end
		else
			if object[event]~=callback then
				object[event] = {object[event], callback};
			end
		end
	end
	return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

mainVisible=true;
maliceVisible=false
missionVisible=false
timeZoneVisible=false

hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state
language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end
getCurrentDate=function(format)
	if format==nil then format="MM/DD/YYYY" end
	-- get the current date in specified format
	local date=Turbine.Engine:GetDate()
	ret=string.gsub(format,"YYYY",string.format("%04d",date.Year))
	ret=string.gsub(ret,"DD",string.format("%02d",date.Day))
	ret=string.gsub(ret,"MM",string.format("%02d",date.Month))
	return ret
end
-- load saved settings
Settings=PatchDataLoad(Turbine.DataScope.Character, pluginName.."Settings")
if Settings==nil then Settings={} end

-- load the settings and set the window position if possible, otherwise default to center
if Settings.DateFormat==nil then
	if locale=="en" then
		Settings.DateFormat="MM/DD/YYYY"
	else
		Settings.DateFormat="YYYY/MM/DD"
	end
end
if Settings.MainOpacity==nil then
	Settings.MainOpacity=.8
else
	Settings.MainOpacity=euroNormalize(Settings.MainOpacity)
end
if Settings.Opacity==nil then
	Settings.Opacity=1
else
	Settings.Opacity=euroNormalize(Settings.Opacity)
end
if Settings.TrimColor==nil then
	Settings.TrimColor=Turbine.UI.Color(.2,.5,.9)
else
	Settings.TrimColor=Turbine.UI.Color(euroNormalize(Settings.TrimColor.A),euroNormalize(Settings.TrimColor.R),euroNormalize(Settings.TrimColor.G),euroNormalize(Settings.TrimColor.B))
end
if Settings.ForeColor==nil then
-- gold	Settings.ForeColor=Turbine.UI.Color(1,.9,.5)
	Settings.ForeColor=Turbine.UI.Color.White
else
	Settings.ForeColor=Turbine.UI.Color(euroNormalize(Settings.ForeColor.A),euroNormalize(Settings.ForeColor.R),euroNormalize(Settings.ForeColor.G),euroNormalize(Settings.ForeColor.B))
end
if Settings.BackColor==nil then
	Settings.BackColor=Turbine.UI.Color(.05,.05,.05)
else
	Settings.BackColor=Turbine.UI.Color(euroNormalize(Settings.BackColor.A),euroNormalize(Settings.BackColor.R),euroNormalize(Settings.BackColor.G),euroNormalize(Settings.BackColor.B))
end
if Settings.HeadingsColor==nil then
	Settings.HeadingsColor=Turbine.UI.Color(1,1,1);
else
	Settings.HeadingsColor=Turbine.UI.Color(euroNormalize(Settings.HeadingsColor.A),euroNormalize(Settings.HeadingsColor.R),euroNormalize(Settings.HeadingsColor.G),euroNormalize(Settings.HeadingsColor.B))
end
if Settings.ListTextColor==nil then
	Settings.ListTextColor=Turbine.UI.Color(1,1,1);
else
	Settings.ListTextColor=Turbine.UI.Color(euroNormalize(Settings.ListTextColor.A),euroNormalize(Settings.ListTextColor.R),euroNormalize(Settings.ListTextColor.G),euroNormalize(Settings.ListTextColor.B))
end
if Settings.Font==nil then
	Settings.Font=Turbine.UI.Lotro.Font.Verdana20;
end
if Settings.Language==nil then
	Settings.Language=-1
else
	if Settings.Language>0 then
		language=Settings.Language
	end
end
if Settings.DataVersion==nil then
	Settings.DataVersion=plugin:GetVersion()
end
if Settings.LoadMinimized==nil then
	Settings.LoadMinimized=false
end
if Settings.ShowIconWhenMinimized==nil then
	Settings.ShowIconWhenMinimized=true
end
if Settings.UseMiniIcon==nil then
	Settings.UseMiniIcon=false
end
if Settings.MiniIconOpaque==nil then
	Settings.MiniIconOpaque=true
end

--***
if Settings.DataVersion~=Plugins[pluginName]:GetVersion() then
	-- incorporate ALL data changes by DataVersion - this will guarantee all users can auto-update to latest version no matter what prior version they had and what versions they skipped
	-- ver 1.1 -> 1.2, mainWindow renamed maliceWindow, fix settings
	if Settings.DataVersion==0.99 or Settings.DataVersion==1.1 then
		Settings.MaliceTopPercent=Settings.MainTopPercent
		Settings.MaliceLeftPercent=Settings.MainLeftPercent
		Settings.MaliceWidthPercent=Settings.MainWidthPercent
		Settings.MaliceHeightPercent=Settings.MainHeightPercent
		Settings.MaliceTop=Settings.MainTop
		Settings.MaliceLeft=Settings.MainLeft
		Settings.MaliceWidth=Settings.MainWidth
		Settings.MaliceHeight=Settings.MainHeight
		Settings.MainTopPercent=nil
		Settings.MainLeftPercent=nil
		Settings.MainWidthPercent=nil
		Settings.MainHeightPercent=nil
		Settings.MainTop=nil
		Settings.MainLeft=nil
		Settings.MainWidth=nil
		Settings.MainHeight=nil
		-- incrementally update data version so each successive change gets applied
		Settings.DataVersion=1.2
	end
end

-- now import
import (importPath.."FontSupport")
fontMetric=FontMetric()
import (importPath.."ScalableButton")
import (importPath.."DropDownList")
import (importPath.."RadioButtonGroup")
import (importPath.."Spinner")
import (importPath.."Calendar")
-- init stuff that depends on calendar functions
if Settings.TimeZoneOffset==nil then Settings.TimeZoneOffset=getTimeZone() end -- -4 = servertime
getVariant=function(epochDate)
	-- epochDate should be an unadjusted date with the current time (this routine accounts for timezone and resettime)
	local resetTime=3600*3 -- we subtract this from the time to allow for the reset at 03:00 servertime
	if epochDate==nil then
		epochDate=getEpochTime()-Settings.TimeZoneOffset*3600
	else
		epochDate=epochDate-Settings.TimeZoneOffset*3600
	end
	if Settings.Debug then Turbine.Shell.WriteLine("GMT epochDate: "..tostring(epochDate)) end
	epochDate=epochDate-resetTime
	if Settings.Debug then Turbine.Shell.WriteLine("GMT reset adjusted epochTime: "..tostring(epochDate)) end
	if Settings.Debug then Turbine.Shell.WriteLine("Days since 1/1/1970 03:00 GMT: "..tostring(math.floor(epochDate/86400))) end
	local _,tmpVariant=math.modf((math.floor(epochDate/86400))/6) -- floor(date/86400)  is days since 1/1/1970 - zero based - 86400 seconds per day divided by days in cycle to get remainder which is fractional part of current cycle
	if Settings.Debug then Turbine.Shell.WriteLine("Cycle Fraction: "..tostring(tmpVariant)) end
	tmpVariant=math.floor(tmpVariant*6+.1) -- day of cycle as an integer (rounded in case we get any .999xx values) - zero based
	if Settings.Debug then Turbine.Shell.WriteLine("0 based Cycle Day: "..tostring(tmpVariant)) end
	return tmpVariant+1 -- tmpVariant is 0 based
end
displayVariant=getVariant()
import (importPath.."DebugWindow")
if Settings.Debug then debugWindow:SetVisible(true) end
import (importPath.."OptionsWindow")
import (importPath.."PopUpDialog")
import (importPath.."MaliceData_"..locale)
import (importPath.."MaliceSchedule")
import (importPath.."TimeZoneWindow")

do
	initMainHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	initMainWidth=200
	if initMainWidth>displayWidth then initMainWidth=displayWidth end
	if initMainHeight>displayHeight then initMainHeight=displayHeight end
	initMainLeft=(displayWidth - initMainWidth) / 2
	initMainTop=(displayHeight - initMainHeight) / 2

	initMaliceHeight=600;
	initMaliceWidth=800;
	if initMaliceWidth>displayWidth then initMaliceWidth=displayWidth end
	if initMaliceHeight>displayHeight then initMaliceHeight=displayHeight end
	initMaliceLeft=(displayWidth - initMaliceWidth) / 2;
	initMaliceTop=(displayHeight - initMaliceHeight) / 2;

	initMissionHeight=600;
	initMissionWidth=800;
	if initMissionWidth>displayWidth then initMissionWidth=displayWidth end
	if initMissionHeight>displayHeight then initMissionHeight=displayHeight end
	initMissionLeft=(displayWidth - initMissionWidth) / 2;
	initMissionTop=(displayHeight - initMissionHeight) / 2;
	if Settings.DisplayWidth==nil or Settings.DisplayHeight==nil then
		-- no settings, go with init
	else
		if Settings.DisplayWidth~=displayWidth or Settings.DisplayHeight~=displayHeight then
			-- resolution has changed, use percents to determine new position/size (drift will be irrelovent compared to resolution change)
			Settings.MainTop=math.floor(euroNormalize(Settings.MainTopPercent)*displayHeight+.5)
			Settings.MainLeft=math.floor(euroNormalize(Settings.MainLeftPercent)*displayWidth+.5)
			Settings.MainHeight=math.floor(euroNormalize(Settings.MainHeightPercent)*displayHeight+.5)
			Settings.MainWidth=math.floor(euroNormalize(Settings.MainWidthPercent)*displayHeight+.5)
			Settings.MaliceTop=math.floor(euroNormalize(Settings.MaliceTopPercent)*displayHeight+.5)
			Settings.MaliceLeft=math.floor(euroNormalize(Settings.MaliceLeftPercent)*displayWidth+.5)
			Settings.MaliceHeight=math.floor(euroNormalize(Settings.MaliceHeightPercent)*displayHeight+.5)
			Settings.MaliceWidth=math.floor(euroNormalize(Settings.MaliceWidthPercent)*displayHeight+.5)
			Settings.MissionTop=math.floor(euroNormalize(Settings.MissionTopPercent)*displayHeight+.5)
			Settings.MissionLeft=math.floor(euroNormalize(Settings.MissionLeftPercent)*displayWidth+.5)
			Settings.MissionHeight=math.floor(euroNormalize(Settings.MissionHeightPercent)*displayHeight+.5)
			Settings.MissionWidth=math.floor(euroNormalize(Settings.MissionWidthPercent)*displayHeight+.5)
		end
		if Settings.MainTop~=nil then initMainTop=Settings.MainTop end
		if Settings.MainLeft~=nil then initMainLeft=Settings.MainLeft end
		if Settings.MainWidth~=nil then initMainWidth=Settings.MainWidth end
		if Settings.MainHeight~=nil then initMainHeight=Settings.MainHeight end
		if Settings.MaliceTop~=nil then initMaliceTop=Settings.MaliceTop end
		if Settings.MaliceLeft~=nil then initMaliceLeft=Settings.MaliceLeft end
		if Settings.MaliceWidth~=nil then initMaliceWidth=Settings.MaliceWidth end
		if Settings.MaliceHeight~=nil then initMaliceHeight=Settings.MaliceHeight end
		if Settings.MissionTop~=nil then initMissionTop=Settings.MissionTop end
		if Settings.MissionLeft~=nil then initMissionLeft=Settings.MissionLeft end
		if Settings.MissionWidth~=nil then initMissionWidth=Settings.MissionWidth end
		if Settings.MissionHeight~=nil then initMissionHeight=Settings.MissionHeight end
	end
	-- enforce current resolution limits
	if initMainLeft>(Turbine.UI.Display.GetWidth()-initMainWidth) then initMainLeft=Turbine.UI.Display.GetWidth()-initMainWidth end
	if initMainLeft<0 then initMainLeft=0 end
	if initMainWidth>(Turbine.UI.Display.GetWidth()-initMainLeft) then initMainWidth=Turbine.UI.Display.GetWidth()-initMainLeft end
	if initMainTop>(Turbine.UI.Display.GetHeight()-initMainHeight) then initMainTop=Turbine.UI.Display.GetHeight()-initMainHeight end
	if initMainTop<0 then initMainTop=0 end
	if initMainHeight>(Turbine.UI.Display.GetHeight()-initMainTop) then initMainTop=Turbine.UI.Display.GetHeight()-initMainHeight end

	if initMaliceLeft>(Turbine.UI.Display.GetWidth()-initMaliceWidth) then initMaliceLeft=Turbine.UI.Display.GetWidth()-initMaliceWidth end
	if initMaliceLeft<0 then initMaliceLeft=0 end
	if initMaliceWidth>(Turbine.UI.Display.GetWidth()-initMaliceLeft) then initMaliceWidth=Turbine.UI.Display.GetWidth()-initMaliceLeft end
	if initMaliceTop>(Turbine.UI.Display.GetHeight()-initMaliceHeight) then initMaliceTop=Turbine.UI.Display.GetHeight()-initMaliceHeight end
	if initMaliceTop<0 then initMaliceTop=0 end
	if initMaliceHeight>(Turbine.UI.Display.GetHeight()-initMaliceTop) then initMaliceTop=Turbine.UI.Display.GetHeight()-initMaliceHeight end

	if initMissionLeft>(Turbine.UI.Display.GetWidth()-initMissionWidth) then initMissionLeft=Turbine.UI.Display.GetWidth()-initMissionWidth end
	if initMissionLeft<0 then initMissionLeft=0 end
	if initMissionWidth>(Turbine.UI.Display.GetWidth()-initMissionLeft) then initMissionWidth=Turbine.UI.Display.GetWidth()-initMissionLeft end
	if initMissionTop>(Turbine.UI.Display.GetHeight()-initMissionHeight) then initMissionTop=Turbine.UI.Display.GetHeight()-initMissionHeight end
	if initMissionTop<0 then initMissionTop=0 end
	if initMissionHeight>(Turbine.UI.Display.GetHeight()-initMissionTop) then initMissionTop=Turbine.UI.Display.GetHeight()-initMissionHeight end

end

-- create mini window
mainWindow=Turbine.UI.Window()
mainWindow:SetOpacity(Settings.MainOpacity)
initMainHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+2
if initMainHeight<32 then initMainHeight=24 end
fontMetric:SetFont(Settings.Font)
mainWindow:SetSize(fontMetric:GetTextWidth(Resource[language][32]..": 88")+29,initMainHeight) -- 1px border and margin
-- default center
mainWindow:SetPosition(initMainLeft,initMainTop)
initMainLeft=nil
initMainTop=nil
initMainWidth=nil
initMainHeight=nil
mainWindow:SetBackColor(Settings.TrimColor)
mainWindow.Back=Turbine.UI.Control()
mainWindow.Back:SetParent(mainWindow)
mainWindow.Back:SetSize(mainWindow:GetWidth()-2,mainWindow:GetHeight()-2)
mainWindow.Back:SetPosition(1,1)
mainWindow.Back:SetBackColor(Settings.BackColor)
mainWindow.Back:SetMouseVisible(false)
mainWindow.Malice=Turbine.UI.Label()
mainWindow.Malice:SetMouseVisible(false)
mainWindow.Malice:SetParent(mainWindow.Back)
mainWindow.Malice:SetFont(Settings.Font)
mainWindow.Malice:SetSize(mainWindow.Back:GetWidth()-27,mainWindow.Back:GetHeight()-2)
mainWindow.Malice:SetPosition(1,1)
mainWindow.Malice:SetText(Resource[language][32]..": "..tostring(displayVariant))
mainWindow.FontSelect=FontSelect()
mainWindow.FontSelect:SetParent(mainWindow)
mainWindow.FontSelect:SetPosition(mainWindow.Malice:GetLeft()+mainWindow.Malice:GetWidth()+5,mainWindow:GetHeight()/2-10)
mainWindow.FontSelect:SetFont(Settings.Font)
mainWindow.FontSelect.FontChanged=function()
	Settings.Font=mainWindow.FontSelect:GetFont()
	mainWindow:SetFont(Settings.Font)
	if maliceWindow~=nil then maliceWindow:SetFont(Settings.Font) end
	if missionWindow~=nil then missionWindow:SetFont(Settings.Font) end
	if TimeZoneWindow~=nil then TimeZoneWindow:SetFont(Settings.Font) end
end
mainWindow.SetFont=function()
	-- resize and relayout all controls
	fontMetric:SetFont(Settings.Font)
	local newMainHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+2
	if newMainHeight<32 then newMainHeight=24 end
	mainWindow:SetSize(fontMetric:GetTextWidth(Resource[language][32]..": 88")+29,newMainHeight) -- 1px border and margin
	mainWindow.Back:SetSize(mainWindow:GetWidth()-2,mainWindow:GetHeight()-2)
	mainWindow.Malice:SetSize(mainWindow.Back:GetWidth()-27,mainWindow.Back:GetHeight()-2)
	mainWindow.Malice:SetFont(Settings.Font)
	mainWindow.Malice:SetText(mainWindow.Malice:GetText())
	mainWindow.FontSelect:SetPosition(mainWindow.Malice:GetLeft()+mainWindow.Malice:GetWidth()+5,mainWindow:GetHeight()/2-10)
end
mainWindow:SetVisible(true)

function UnloadPlugin()
	SaveData();

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mainWindow:RemoveShellCommands();
	RemoveCallback(Turbine.Chat, "Received", TimeZoneWindow.ChatListener)
end

function SaveData()
	-- save resolution so we can compare next time we are loaded
	Settings.DisplayWidth=displayWidth
	Settings.DisplayHeight=displayHeight

	Settings.MainTopPercent=mainWindow:GetTop()/displayHeight
	Settings.MainLeftPercent=mainWindow:GetLeft()/displayWidth
	Settings.MainTop=mainWindow:GetTop()
	Settings.MainLeft=mainWindow:GetLeft()
	Settings.MainWidth=mainWindow:GetWidth()
	Settings.MainHeight=mainWindow:GetHeight()
	if maliceWindow~=nil then
		Settings.MaliceTopPercent=maliceWindow:GetTop()/displayHeight
		Settings.MaliceLeftPercent=maliceWindow:GetLeft()/displayWidth
		Settings.MaliceWidthPercent=maliceWindow:GetWidth()/displayWidth
		Settings.MaliceHeightPercent=maliceWindow:GetHeight()/displayHeight
		Settings.MaliceTop=maliceWindow:GetTop()
		Settings.MaliceLeft=maliceWindow:GetLeft()
		Settings.MaliceWidth=maliceWindow:GetWidth()
		Settings.MaliceHeight=maliceWindow:GetHeight()
	end
	if missionWindow~=nil then
		Settings.MissionTopPercent=missionWindow:GetTop()/displayHeight
		Settings.MissionLeftPercent=missionWindow:GetLeft()/displayWidth
		Settings.MissionWidthPercent=missionWindow:GetWidth()/displayWidth
		Settings.MissionHeightPercent=missionWindow:GetHeight()/displayHeight
		Settings.MissionTop=missionWindow:GetTop()
		Settings.MissionLeft=missionWindow:GetLeft()
		Settings.MissionWidth=missionWindow:GetWidth()
		Settings.MissionHeight=missionWindow:GetHeight()
	end
	PatchDataSave( Turbine.DataScope.Character, pluginName.."Settings", Settings);
end
mainWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		if missionWindow~=nil then
			missionWindow:SetVisible(false)
			-- hide the calendar if it is showing
			missionWindow.Date.Calendar:SetVisible(false)
		end
		missionVisible=false
		if maliceWindow~=nil then maliceWindow:SetVisible(false) end
		maliceVisible=false
		if TimeZoneWindow~=nil then TimeZoneWindow:SetVisible(false) end
		timeZoneVisible=false
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			mainWindow:SetVisible(mainVisible)
			if maliceWindow~=nil then maliceWindow:SetVisible(maliceVisible) end
			if missionWindow~=nil then missionWindow:SetVisible(missionVisible) end
			if TimeZoneWindow~=nil then TimeZoneWindow:SetVisible(timeZoneVisible) end
		else
			mainVisible=mainWindow:IsVisible()
			mainWindow:SetVisible(false)
			if maliceWindow~=nil then
				maliceVisible=maliceWindow:IsVisible()
				maliceWindow:SetVisible(false)
			end
			if missionWindow~=nil then
				missionVisible=missionWindow:IsVisible()
				missionWindow:SetVisible(false)
				-- hide the calendar if it is showing
				missionWindow.Date.Calendar:SetVisible(false)
			end
			if TimeZoneWindow~=nil then
				timeZoneVisible=TimeZoneWindow:IsVisible()
				TimeZoneWindow:SetVisible(false)
			end
		end
	end
end
mainWindow:SetWantsKeyEvents(true);
mainWindow:SetWantsUpdates(true)
mainWindow.RemoveShellCommands=function(sender,args)
	Turbine.Shell.RemoveCommand(mainWindow.shellCmd)
end

mainWindow.Menu=Turbine.UI.ContextMenu()
mainWindow.Menu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][33]))
mainWindow.Menu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][34]))
mainWindow.Menu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][39]))
mainWindow.Menu:GetItems():Get(1).Click=function(sender,args)
	if maliceWindow==nil then
		import (importPath.."MaliceWindow")
	end
	maliceWindow:SetVisible(true)
	maliceVisible=true
end
mainWindow.Menu:GetItems():Get(2).Click=function(sender,args)
	-- import window files
	if missionWindow==nil then
		import (importPath.."MissionData_"..locale) -- must be imported before MissionWindow
		import (importPath.."Schedule") -- must be imported before MissionWindow
		import (importPath.."MissionWindow")
	end

	missionWindow:SetVisible(true)
	missionVisible=true
end
mainWindow.Menu:GetItems():Get(3).Click=function(sender,args)
	TimeZoneWindow:SetVisible(true)
	timeZoneVisible=true
end
mainWindow.MoveX=-1
mainWindow.MoveY=0
mainWindow.MouseDown=function(sender,args)
	if args.Button==1 then
		if mainWindow:IsControlKeyDown() or mainWindow:IsShiftKeyDown() or mainWindow:IsAltKeyDown() then
			mainWindow.MoveX=args.X
			mainWindow.MoveY=args.Y
		end
	end
end
mainWindow.MouseUp=function(sender,args)
	mainWindow.MoveX=-1
	mainWindow.MoveY=0
end
mainWindow.MouseMove=function(sender,args)
	if mainWindow.MoveX~=-1 and (args.X~=mainWindow.MoveX or args.Y~= mainWindow.MoveY) then
		local newLeft=mainWindow:GetLeft()-(mainWindow.MoveX-args.X)
		local newTop=mainWindow:GetTop()-(mainWindow.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end
		if newLeft>(Turbine.UI.Display.GetWidth()-mainWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-mainWindow:GetWidth() end
		if newTop<0 then newTop=0 end
		if newTop>(Turbine.UI.Display.GetHeight()-mainWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-mainWindow:GetHeight() end
		mainWindow:SetPosition(newLeft,newTop)
		end
end


mainWindow.MouseClick=function(sender,args)
	if args.Button==2 then
		local x,y=Turbine.UI.Display:GetMousePosition()
		mainWindow.Menu:ShowMenuAt(x,y)
	end
end
mainWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand(pluginName,mainWindow.shellCmd);

mainWindow.shellCmd.Execute = function(sender, cmd, args)
	if (string.lower(cmd) == string.lower(pluginName)) then
		local pos1=string.find(args," ",0,true);
		local command;
		if pos1~=nil and pos1>0 then
			command=string.lower(string.sub(args,1,pos1-1));
		else
			command=string.lower(args);
		end
		if (command=="show") then
			if string.lower(args)=="show malice" then
				if maliceWindow==nil then
					import (importPath.."MaliceWindow")
				end
				maliceWindow:SetVisible(true)
				maliceVisible=true
			else
				mainWindow:SetVisible(true)
				mainVisible=true
			end
		elseif (command=="show mission") then
			if missionWindow==nil then
				import (importPath.."MissionData_"..locale) -- must be imported before MissionWindow
				import (importPath.."Schedule") -- must be imported before MissionWindow
				import (importPath.."MissionWindow")
			end
			missionWindow:SetVisible(true)
			missionVisible=true
		elseif (command=="hide") then
			if maliceWindow==nil then maliceWindow:SetVisible(false) end
			mainWindow:SetVisible(false)
			if missionWindow==nil then missionWindow:SetVisible(false) end
			mainVisible=false
			maliceVisible=false
			missionVisible=false
			OptionsWindow:SetVisible(false)
		elseif (command=="options") then
			OptionsWindow:SetVisible(true)
		elseif (command=="timezone") then
			TimeZoneWindow:SetVisible(true)
		elseif (command=="debug") then
			if string.lower(args)=="debug on" then
				Settings.Debug=true
				debugWindow:SetVisible(true)
			elseif string.lower(args)=="debug off" then
				Settings.Debug=false
				debugWindow:SetVisible(false)
			else
				-- old style, don't set Settings flag, debug won't persist through reload and chat messages won't generate, only the interactive debug window will show
				debugWindow:SetVisible(true)
			end
		elseif (command=="toggle") then
			mainWindow:SetVisible(not mainWindow:IsVisible())
			mainVisible=mainWindow:IsVisible()
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /"..pluginName.." show");
			Turbine.Shell.WriteLine("       Displays "..pluginName.." main window.");
			Turbine.Shell.WriteLine("  /"..pluginName.." show malice");
			Turbine.Shell.WriteLine("       Displays "..pluginName.." malice window.");
			Turbine.Shell.WriteLine("  /"..pluginName.." show mission");
			Turbine.Shell.WriteLine("       Displays "..pluginName.." mission window.");
			Turbine.Shell.WriteLine("  /"..pluginName.." hide");
			Turbine.Shell.WriteLine("       Hides all "..pluginName.." windows.");
			Turbine.Shell.WriteLine("  /"..pluginName.." toggle");
			Turbine.Shell.WriteLine("       Toggles "..pluginName.." (shows main window it if it was hidden, hides it if it was showing).");
			Turbine.Shell.WriteLine("  /"..pluginName.." options");
			Turbine.Shell.WriteLine("       Displays "..pluginName.." Options window.");
		end
	end
end
mainWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /"..pluginName.." show [malice|mission]\n       Displays "..pluginName..".\n  /"..pluginName.." hide\n       Hides "..pluginName..".\n  /"..pluginName.." toggle\n       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).\n  /"..pluginName.." options\n       Displays "..pluginName.." Options window");
end
mainWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return(pluginName.." - usage: /"..pluginName.." show | hide | toggle");
end

function mainWindow:Update( sender, args )
	if (Plugins[pluginName] ~= nil) and (not mainWindow.Loaded) then
		if not mainWindow.Refreshing then
			Turbine.Shell.WriteLine(pluginName.." "..Plugins[pluginName]:GetVersion()..Resource[language][3]);
		end
		Plugins[pluginName].Unload = function(mainWindow,sender,args)
			UnloadPlugin();
		end
		mainWindow.Loaded=true
	end
	if mainWindow.Loaded then
		if mainWindow.updateTime==nil or Turbine.Engine:GetGameTime()>mainWindow.updateTime then
			if mainWindow.displayedHour==nil or mainWindow.displayedHour~=Turbine.Engine:GetDate().Hour then
				-- refresh the variant display once an hour so that if we pass the reset hour it will be properly reflected
				mainWindow.displayedHour=Turbine.Engine:GetDate().Hour
				displayVariant=getVariant()
				mainWindow.Malice:SetText(Resource[language][32]..": "..tostring(displayVariant))
			end
			mainWindow.updateTime=Turbine.Engine:GetGameTime()+1
		end
	end
end

--optWindow=OptionsWindow();

--optWindow:SetZOrder(mapWindow:GetZOrder()+1);
debugWindow:SetZOrder(mainWindow:GetZOrder());
